import { ServiceType } from "./definitions";
import { ServiceFilterConstructor } from "./filters/ServiceFilter";
import { HAPClient, HAPClientConnection } from "./HAPClient";
import { HAPServer } from "./HAPServer";
import { AccessoryInfo } from "./storage/AccessoryInfo";
import { ClientInfo } from "./storage/ClientInfo";
import { IdentifierCache } from "./storage/IdentifierCache";
export declare class HAPProxy {
    readonly client: HAPClient;
    readonly server: HAPServer;
    readonly identifierCache: IdentifierCache;
    serviceFilterDefinitions: Record<string, ServiceFilterConstructor>;
    private serviceFilters;
    serverToClientConnections: Record<string, HAPClientConnection>;
    constructor(clientInfo: ClientInfo, accessoryInfo: AccessoryInfo);
    listen(targetPort?: number): void;
    addServiceFilter(serviceType: ServiceType, filterDefinition: ServiceFilterConstructor): void;
    private buildFiltersFromCache;
    private getOrCreateServiceFilter;
    private getOrCreateCharacteristicFilter;
    private getCharacteristicFilter;
    private handleServerConnection;
    private handleServerUnpaired;
    private forwardEvent;
    private handleClientDisconnected;
    private handleServerDisconnected;
    private matchConnections;
    private handleServerAccessories;
    private handleServerGetCharacteristics;
    private handleServerSetCharacteristics;
    private handleServerPrepareWrite;
    private handleServerResource;
    private static responseToServerResponse;
}
//# sourceMappingURL=HAPProxy.d.ts.map