"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
// we are running ciao beta right now, disable the debug log
if (!process.env.DEBUG) {
    process.env.DEBUG = "ciao:disabled";
}
else if (!process.env.DEBUG.includes("ciao")) {
    process.env.DEBUG += ",ciao:disabled";
}
const punycode_1 = require("punycode");
const AccessoryInfo_1 = require("./storage/AccessoryInfo");
const HAPProxy_1 = require("./HAPProxy");
const ClientInfo_1 = require("./storage/ClientInfo");
const commander_1 = require("commander");
function getVersion() {
    const packageJson = require("../package.json");
    return packageJson.version;
}
// DEBUG=HAPClient:*,HAPServer,HAPServer:*,HAPProxy,DataStream:* ts-node --files src/cli.ts
// DEBUG=Accessory,HAPServer,StreamController,DataStream:*,EventedHTTPServer ts-node --files src/Core.ts
// TODO code linting etc (code style)
const command = new commander_1.Command("hap-proxy")
    .version(punycode_1.version)
    .option("-p, --port <port>", "define the proxy port", parseInt, 60141)
    .requiredOption("-t, --target-name <instance name>", "define the instance name of the device which should be proxied")
    .requiredOption("-c, --target-pincode <pincode>", "define the pincode with dashes of the homekit device to be proxied")
    .option("--proxy-pincode <pincode>", "define a separate pincode for the proxy server");
command.parse(process.argv);
const opts = command.opts();
const port = opts.port || 0;
const targetName = opts.targetName;
const targetPincode = opts.targetPincode;
const proxyName = "Proxy " + targetName;
const proxyPincode = opts.proxyPincode || targetPincode;
console.log(`Creating '${proxyName} to proxy ${targetName} on port ${port}...'`);
const accessoryInfo = new AccessoryInfo_1.AccessoryInfo(proxyName, proxyPincode);
const clientInfo = new ClientInfo_1.ClientInfo(targetName, targetPincode);
const proxy = new HAPProxy_1.HAPProxy(clientInfo, accessoryInfo);
proxy.listen(port);
//# sourceMappingURL=cli.js.map