/// <reference types="node" />
import { Socket } from "net";
import { HAPClientConnection } from "../HAPClient";
import { DataStreamConnection, DataStreamConnectionEventMap } from "./DataStreamConnection";
export declare class DataStreamClient {
    private connections;
    newConnection(clientConnection: HAPClientConnection, host: string, port: number, salt: Buffer): DataStreamClientConnection;
    private connectionClosed;
}
export declare enum DataStreamClientConnectionEvents {
    CONNECTED = "connect"
}
export interface DataStreamClientConnectionEventMap extends DataStreamConnectionEventMap {
    [DataStreamClientConnectionEvents.CONNECTED]: () => void;
}
export declare class DataStreamClientConnection extends DataStreamConnection<DataStreamClientConnectionEventMap> {
    private connection;
    private connectPromise?;
    private socketConnectResolve?;
    private socketConnectReject?;
    constructor(socket: Socket, connection: HAPClientConnection, encryptionKey: Buffer, decryptionKey: Buffer);
    ensureConnected(): Promise<void>;
    private handleConnected;
    protected handleError(error: Error): void;
}
//# sourceMappingURL=DataStreamClient.d.ts.map