/// <reference types="node" />
import { HAPServerConnection } from "./HAPServer";
import { CharacteristicFilterConstructor, CharacteristicFilterControlPoint, CharacteristicFilterR } from "./filters/CharacteristicFilter";
import { ServiceFilter } from "./filters/ServiceFilter";
import { HAPClientConnection } from "./HAPClient";
import { HAPProxy } from "./HAPProxy";
/**
 * Service "Protocol Information"
 */
export declare class AccessoryInformationServiceNameCharacteristicFilter extends CharacteristicFilterR<string> {
    filterRead(connection: HAPServerConnection, clientConnection: HAPClientConnection, readValue: string): Promise<string>;
}
export declare class AccessoryInformationServiceFilter extends ServiceFilter {
    characteristicFilterDefinitions: Record<string, CharacteristicFilterConstructor<any>>;
}
/**
 * Service "DataStreamManagement"
 */
export declare class DataStreamTransportManagementServiceSetupDataStreamTransportCharacteristicFilter extends CharacteristicFilterControlPoint<string> {
    private dataStreamProxy;
    constructor(context: HAPProxy, parent: ServiceFilter, iid: number);
    connectionContext: Record<string, {
        lastResponse: string;
        controllerKeySalt: Buffer;
        proxyControllerKeySalt: Buffer;
    }>;
    filterRead(serverConnection: HAPServerConnection, clientConnection: HAPClientConnection, readValue: string): Promise<string>;
    filterWrite(serverConnection: HAPServerConnection, clientConnection: HAPClientConnection, writtenValue: string): Promise<string>;
    filterWriteResponse(serverConnection: HAPServerConnection, clientConnection: HAPClientConnection, writeResponseValue: string): Promise<string>;
}
export declare class DataStreamTransportManagementServiceVersionCharacteristic extends CharacteristicFilterR<string> {
    filterRead(serverConnection: HAPServerConnection, clientConnection: HAPClientConnection, readValue: string): Promise<string>;
}
export declare class DataStreamTransportManagementServiceFilter extends ServiceFilter {
    constructor(context: HAPProxy, aid: number, iid: number);
    characteristicFilterDefinitions: Record<string, CharacteristicFilterConstructor<any>>;
}
//# sourceMappingURL=filters.d.ts.map