"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CharacteristicFilterControlPoint = exports.CharacteristicFilterW = exports.CharacteristicFilterR = exports.CharacteristicFilterRW = exports.CharacteristicFilter = void 0;
/**
 * Read/write (with write response) characteristic filter
 */
class CharacteristicFilter {
    /**
     * Creates a new instance of a CharacteristicFilter
     *
     * @param context {HAPProxy} - the associated proxy instance
     * @param parent {ServiceFilter} - the associated ServiceFilter instance
     * @param iid {number} - instance id of the characteristic
     */
    constructor(context, parent, iid) {
        this.context = context;
        this.parent = parent;
        this.iid = iid;
    }
}
exports.CharacteristicFilter = CharacteristicFilter;
/**
 * Read/write characteristic filter
 */
class CharacteristicFilterRW extends CharacteristicFilter {
    filterWriteResponse(serverConnection, clientConnection, writeResponseValue) {
        return __awaiter(this, void 0, void 0, function* () {
            return writeResponseValue;
        });
    }
}
exports.CharacteristicFilterRW = CharacteristicFilterRW;
/**
 * Read only characteristic filter
 */
class CharacteristicFilterR extends CharacteristicFilterRW {
    filterWrite(serverConnection, clientConnection, writtenValue) {
        return __awaiter(this, void 0, void 0, function* () {
            return writtenValue; // its not allowed so just forward it. Client will return an error
        });
    }
}
exports.CharacteristicFilterR = CharacteristicFilterR;
// noinspection JSUnusedGlobalSymbols
/**
 * Write only characteristic filter
 */
class CharacteristicFilterW extends CharacteristicFilterRW {
    filterRead(serverConnection, clientConnection, readValue) {
        return __awaiter(this, void 0, void 0, function* () {
            return readValue;
        });
    }
}
exports.CharacteristicFilterW = CharacteristicFilterW;
/**
 * Control point characteristic filter
 */
class CharacteristicFilterControlPoint extends CharacteristicFilter {
    filterRead(serverConnection, clientConnection, readValue) {
        return __awaiter(this, void 0, void 0, function* () {
            return readValue;
        });
    }
}
exports.CharacteristicFilterControlPoint = CharacteristicFilterControlPoint;
//# sourceMappingURL=CharacteristicFilter.js.map