import { HAPProxy } from "../HAPProxy";
import { CharacteristicFilter, CharacteristicFilterConstructor } from "./CharacteristicFilter";
export declare abstract class ServiceFilter {
    readonly context: HAPProxy;
    readonly aid: number;
    readonly iid: number;
    readonly characteristicsFilters: Record<number, CharacteristicFilter<any>>;
    /**
     * Record of filter definitions. Key is the CharacteristicType and value the constructor of the CharacteristicFilter.
     */
    abstract characteristicFilterDefinitions: Record<string, CharacteristicFilterConstructor<any>>;
    /**
     * Creates a new instance of a ServiceFilter
     *
     * @param context {HAPProxy} - the associated proxy instance
     * @param aid {number} - accessory id
     * @param iid {number} - instance id of the service
     */
    constructor(context: HAPProxy, aid: number, iid: number);
}
/**
 * Creates a new instance of a ServiceFilter
 *
 * @param context {HAPProxy} - the associated proxy instance
 * @param aid {number} - accessory id
 * @param iid {number} - instance id of the service
 */
export declare type ServiceFilterConstructor = new (context: HAPProxy, aid: number, iid: number) => ServiceFilter;
//# sourceMappingURL=ServiceFilter.d.ts.map