import { MulticastOptions } from 'bonjour-hap';
import { ClientInfo } from "../storage/ClientInfo";
import { EventEmitter } from "./EventEmitter";
import { HAPAccessoryCategory } from "../types/hap-proxy";
export interface HAPDeviceInfo {
    host: string;
    port: number;
    clientId: string;
    protocolVersion: string;
    configNumber: number;
    statusFlag: number;
    paired: boolean;
    category: HAPAccessoryCategory;
}
export declare enum BonjourBrowserEvents {
    UPDATE = "update",
    CONFIG_NUMBER_CHANGE = "config-change",
    PAIRED_CHANGE = "paired-change"
}
export declare type BonjourBrowserEventMap = {
    [BonjourBrowserEvents.UPDATE]: (deviceInfo: HAPDeviceInfo) => void;
    [BonjourBrowserEvents.CONFIG_NUMBER_CHANGE]: (configNumber: number) => void;
    [BonjourBrowserEvents.PAIRED_CHANGE]: (paired: boolean) => void;
};
export declare class HAPBonjourBrowser extends EventEmitter<BonjourBrowserEventMap> {
    private static readonly TIMEOUT;
    private static readonly INTERVAL;
    readonly clientInfo: ClientInfo;
    private bonjourService;
    private browser?;
    private deviceInfo?;
    private readonly promise;
    private timeout?;
    private promiseResolver?;
    private interval?;
    constructor(clientInfo: ClientInfo, mdnsConfig?: MulticastOptions);
    private handleUp;
    deviceInfoPromise(): Promise<HAPDeviceInfo>;
}
//# sourceMappingURL=HAPBonjourBrowser.d.ts.map