"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SetupCodeGenerator = void 0;
const crypto_1 = __importDefault(require("crypto"));
var SetupCodeGenerator;
(function (SetupCodeGenerator) {
    const invalid = [
        '000-00-000',
        '111-11-111',
        '222-22-222',
        '333-33-333',
        '444-44-444',
        '555-55-555',
        '666-66-666',
        '777-77-777',
        '888-88-888',
        '999-99-999',
        '123-45-678',
        '876-54-321',
    ];
    function generate() {
        return new Promise(((resolve, reject) => {
            crypto_1.default.randomBytes(6, (error, buffer) => {
                if (error) {
                    return reject(error);
                }
                const setupCode = toString(buffer);
                if (invalid.includes(setupCode)) {
                    resolve(generate());
                }
                else {
                    resolve(setupCode);
                }
            });
        }));
    }
    SetupCodeGenerator.generate = generate;
    function toString(buffer) {
        return ('000' + buffer.readUInt16LE(0)).substr(-3) + '-' +
            ('00' + buffer.readUInt16LE(2)).substr(-2) + '-' +
            ('000' + buffer.readUInt16LE(4)).substr(-3);
    }
})(SetupCodeGenerator = exports.SetupCodeGenerator || (exports.SetupCodeGenerator = {}));
//# sourceMappingURL=setup-code.js.map