import { ClientInfo } from "./ClientInfo";
export interface TypeEntry {
    serviceType: string;
    characteristicType: string;
}
export interface IdentifierCacheEntry {
    aid: number;
    serviceIid: number;
    characteristicIid: number;
    serviceType: string;
    characteristicType: string;
}
export declare class IdentifierCache {
    private readonly clientInfo;
    private typeCache;
    private serviceIidCache;
    private loaded;
    constructor(clientInfo: ClientInfo);
    rebuild(): void;
    persists(aid: number, serviceIid: number, characteristicIid: number, serviceType: string, characteristicType: string): void;
    entries(): IdentifierCacheEntry[];
    /**
     * Lookup of the service and characteristic types for the given ids
     *
     * @param aid {number} - accessory id
     * @param iid {number} - instance id of the characteristic
     */
    lookupType(aid: number, iid: number): TypeEntry;
    /**
     * Lookup of the iid of the service for the given ids
     *
     * @param aid {number} - accessory id
     * @param iid {number} - instance id of the characteristic
     */
    lookupServiceIid(aid: number, iid: number): number;
    save(): Promise<void>;
    load(): Promise<void>;
}
//# sourceMappingURL=IdentifierCache.d.ts.map