"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.StorageManager = void 0;
const node_persist_1 = __importDefault(require("node-persist"));
const util_1 = __importDefault(require("util"));
let storageInit = false;
var StorageManager;
(function (StorageManager) {
    let initPromise = Promise.resolve();
    function init() {
        return __awaiter(this, void 0, void 0, function* () {
            if (!storageInit) {
                storageInit = true;
                initPromise = initPromise.then(() => node_persist_1.default.init()); // TODO storage path
            }
            yield initPromise;
        });
    }
    StorageManager.init = init;
    function getItem(key) {
        return node_persist_1.default.getItem(key);
    }
    StorageManager.getItem = getItem;
    function setItem(key, value, options) {
        return node_persist_1.default.setItem(key, value, options);
    }
    StorageManager.setItem = setItem;
    function clientFormatPersistKey(clientId) {
        return util_1.default.format("ClientInfo.%s.json", clientId.toUpperCase());
    }
    StorageManager.clientFormatPersistKey = clientFormatPersistKey;
    function identifierCacheFormatPersistKey(clientId) {
        return util_1.default.format("IdentifierCache.%s.json", clientId.toUpperCase());
    }
    StorageManager.identifierCacheFormatPersistKey = identifierCacheFormatPersistKey;
    function accessoryFormatPersistKey(accessoryName) {
        return util_1.default.format("AccessoryInfo.%s.json", accessoryName.toUpperCase());
    }
    StorageManager.accessoryFormatPersistKey = accessoryFormatPersistKey;
})(StorageManager = exports.StorageManager || (exports.StorageManager = {}));
//# sourceMappingURL=storage.js.map