"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.once = void 0;
function once(func) {
    let called = false;
    return (...args) => {
        if (called) {
            throw new Error("This callback function has already been called by someone else; it can only be called one time.");
        }
        else {
            called = true;
            return func(...args);
        }
    };
}
exports.once = once;
//# sourceMappingURL=once.js.map